Index: c/src/ada-tests/tmtests/tm05/tmtest.adb
===================================================================
--- c/src/ada-tests/tmtests/tm05/tmtest.adb	(revision 6d4e604be8b43c0555cd1c9531fe78ae199a1189)
+++ c/src/ada-tests/tmtests/tm05/tmtest.adb	(revision 6d4e604be8b43c0555cd1c9531fe78ae199a1189)
@@ -0,0 +1,174 @@
+--
+--  TMTEST / BODY
+--
+--  DESCRIPTION:
+--
+--  This package is the implementation of Test 5 of the RTEMS
+--  Timing Test Suite.
+--
+--  DEPENDENCIES: 
+--
+--  
+--
+--  COPYRIGHT (c) 1989, 1990, 1991, 1992, 1993, 1994.
+--  On-Line Applications Research Corporation (OAR).
+--  All rights assigned to U.S. Government, 1994.
+--
+--  This material may be reproduced by or for the U.S. Government pursuant
+--  to the copyright license under the clause at DFARS 252.227-7013.  This
+--  notice must appear in all copies of this file and its derivatives.
+--
+--  tmtest.adb,v 1.3 1995/07/12 19:43:16 joel Exp
+--
+
+with INTERFACES; use INTERFACES;
+with RTEMS;
+with RTEMS_CALLING_OVERHEAD;
+with TEST_SUPPORT;
+with TEXT_IO;
+with TIME_TEST_SUPPORT;
+with UNSIGNED32_IO;
+
+package body TMTEST is
+
+--PAGE
+-- 
+--  INIT
+--
+
+   procedure INIT (
+      ARGUMENT : in     RTEMS.TASK_ARGUMENT
+   ) is
+      TASK_ID : RTEMS.ID;
+      STATUS  : RTEMS.STATUS_CODES;
+   begin
+
+      TEXT_IO.NEW_LINE( 2 );
+      TEXT_IO.PUT_LINE( "*** TIME TEST 5 ***" );
+
+      TMTEST.TEST_INIT;
+
+      RTEMS.TASK_DELETE( RTEMS.SELF, STATUS );
+      TEST_SUPPORT.DIRECTIVE_FAILED( STATUS, "TASK_DELETE OF SELF" );
+
+   end INIT;
+
+--PAGE
+-- 
+--  TEST_INIT
+--
+
+   procedure TEST_INIT
+   is
+      INDEX      : RTEMS.UNSIGNED32;
+      TASK_ENTRY : RTEMS.TASK_ENTRY_POINT;
+      PRIORITY   : RTEMS.TASK_PRIORITY;
+      STATUS     : RTEMS.STATUS_CODES;
+   begin
+
+      PRIORITY := 250;
+
+      for INDEX in 0 .. TIME_TEST_SUPPORT.OPERATION_COUNT
+      loop
+
+         RTEMS.TASK_CREATE( 
+            RTEMS.BUILD_NAME( 'T', 'I', 'M', 'E' ),
+            PRIORITY, 
+            1024, 
+            RTEMS.DEFAULT_MODES,
+            RTEMS.DEFAULT_ATTRIBUTES,
+            TMTEST.TASK_ID( INDEX ),
+            STATUS
+         );
+         TEST_SUPPORT.DIRECTIVE_FAILED( STATUS, "TASK_CREATE LOOP" );
+
+         PRIORITY := PRIORITY - 1;
+
+         if INDEX = 0 then
+            TASK_ENTRY := TMTEST.LOW_TASK'ACCESS;
+         elsif INDEX = TIME_TEST_SUPPORT.OPERATION_COUNT then
+            TASK_ENTRY := TMTEST.HIGH_TASK'ACCESS;
+         else
+            TASK_ENTRY := TMTEST.MIDDLE_TASKS'ACCESS;
+         end if;
+
+         RTEMS.TASK_START( TMTEST.TASK_ID( INDEX ), TASK_ENTRY, 0, STATUS );
+         TEST_SUPPORT.DIRECTIVE_FAILED( STATUS, "TASK_START LOOP" );
+
+      end loop;
+
+   end TEST_INIT;
+
+--PAGE
+-- 
+--  HIGH_TASK
+--
+
+   procedure HIGH_TASK (
+      ARGUMENT : in     RTEMS.TASK_ARGUMENT
+   ) is
+      STATUS       : RTEMS.STATUS_CODES;
+   begin
+
+      TIMER_DRIVER.INITIALIZE;
+         RTEMS.TASK_SUSPEND( RTEMS.SELF, STATUS );
+
+      TMTEST.END_TIME := TIMER_DRIVER.READ_TIMER;
+      TIME_TEST_SUPPORT.PUT_TIME( 
+         "TASK_RESUME causing preempt",
+         TMTEST.END_TIME, 
+         TIME_TEST_SUPPORT.OPERATION_COUNT, 
+         0,
+         RTEMS_CALLING_OVERHEAD.TASK_RESUME
+      );
+
+      RTEMS.SHUTDOWN_EXECUTIVE( 0 );
+
+   end HIGH_TASK;
+
+--PAGE
+-- 
+--  MIDDLE_TASKS
+--
+
+   procedure MIDDLE_TASKS (
+      ARGUMENT : in     RTEMS.TASK_ARGUMENT
+   ) is
+      STATUS       : RTEMS.STATUS_CODES;
+   begin
+ 
+      RTEMS.TASK_SUSPEND( RTEMS.SELF, STATUS );
+
+      TMTEST.TASK_INDEX := TMTEST.TASK_INDEX + 1;
+      RTEMS.TASK_RESUME( TMTEST.TASK_ID( TMTEST.TASK_INDEX ), STATUS );
+ 
+   end MIDDLE_TASKS;
+
+--PAGE
+-- 
+--  LOW_TASK
+--
+
+   procedure LOW_TASK (
+      ARGUMENT : in     RTEMS.TASK_ARGUMENT
+   ) is
+      ID       : RTEMS.ID;
+      STATUS   : RTEMS.STATUS_CODES;
+   begin
+
+      TMTEST.END_TIME := TIMER_DRIVER.READ_TIMER;
+      TIME_TEST_SUPPORT.PUT_TIME( 
+         "TASK_SUSPEND self",
+         TMTEST.END_TIME, 
+         TIME_TEST_SUPPORT.OPERATION_COUNT, 
+         0,
+         RTEMS_CALLING_OVERHEAD.TASK_SUSPEND
+      );
+   
+      TMTEST.TASK_INDEX := 1;
+      TIMER_DRIVER.INITIALIZE;
+      RTEMS.TASK_RESUME( TMTEST.TASK_ID( TMTEST.TASK_INDEX ), STATUS );
+
+   end LOW_TASK;
+
+end TMTEST;
Index: c/src/ada-tests/tmtests/tm05/tmtest.ads
===================================================================
--- c/src/ada-tests/tmtests/tm05/tmtest.ads	(revision 6d4e604be8b43c0555cd1c9531fe78ae199a1189)
+++ c/src/ada-tests/tmtests/tm05/tmtest.ads	(revision 6d4e604be8b43c0555cd1c9531fe78ae199a1189)
@@ -0,0 +1,151 @@
+--
+--  TMTEST / SPECIFICATION
+--
+--  DESCRIPTION:
+--
+--  This package is the specification for Test 5 of the RTEMS
+--  Timing Test Suite.
+--
+--  DEPENDENCIES: 
+--
+--  
+--
+--  COPYRIGHT (c) 1989, 1990, 1991, 1992, 1993, 1994.
+--  On-Line Applications Research Corporation (OAR).
+--  All rights assigned to U.S. Government, 1994.
+--
+--  This material may be reproduced by or for the U.S. Government pursuant
+--  to the copyright license under the clause at DFARS 252.227-7013.  This
+--  notice must appear in all copies of this file and its derivatives.
+--
+--  tmtest.ads,v 1.3 1995/07/12 19:43:17 joel Exp
+--
+
+with TIME_TEST_SUPPORT;
+with TIMER_DRIVER;
+with RTEMS;
+
+package TMTEST is
+
+--
+--  This array contains the IDs of all RTEMS tasks created by this test.
+--
+
+   TASK_ID : array ( RTEMS.UNSIGNED32 
+      range 0 .. TIME_TEST_SUPPORT.OPERATION_COUNT ) of RTEMS.ID;
+
+   TASK_INDEX : RTEMS.UNSIGNED32;
+
+--
+--  The following variable is set to the execution time returned
+--  by the timer.
+--
+
+   END_TIME  : RTEMS.UNSIGNED32;
+
+--
+--  INIT
+--
+--  DESCRIPTION:
+--
+--  This RTEMS task initializes the application.
+--
+
+   procedure INIT (
+      ARGUMENT : in     RTEMS.TASK_ARGUMENT
+   );
+
+--
+--  TEST_INIT
+--
+--  DESCRIPTION:
+--
+--  This subprogram performs test initialization.
+--
+
+   procedure TEST_INIT;
+
+--
+--  HIGH_TASK
+--
+--  DESCRIPTION:
+--
+--  This RTEMS task is the highest priority task in the system.  
+--  It starts the timer and performs a TASK_SUSPEND on SELF.
+--  When this task executes again, it stops the timer and
+--  reports the execution time for a preemptive TASK_RESUME.
+--
+
+   procedure HIGH_TASK (
+      ARGUMENT : in     RTEMS.TASK_ARGUMENT
+   );
+
+--
+--  MIDDLE_TASKS
+--
+--  DESCRIPTION:
+--
+--  These RTEMS tasks perform a TASK_SUSPEND on SELF.  When each 
+--  task executes again, it performs preemptive TASK_RESUME on
+--  a higher priority task.
+--
+
+   procedure MIDDLE_TASKS (
+      ARGUMENT : in     RTEMS.TASK_ARGUMENT
+   );
+
+--
+--  LOW_TASK
+--
+--  DESCRIPTION:
+--
+--  This RTEMS task is the lowest priority task in the system.  
+--  When this task executes, it stops the timer and reports the 
+--  execution time for a blocking TASK_SUSPEND.  After this,
+--  it starts the timer and performs a TASK_RESUME on a
+--  higher priority task.
+--
+
+   procedure LOW_TASK (
+      ARGUMENT : in     RTEMS.TASK_ARGUMENT
+   );
+
+--
+--  This is the Initialization Tasks Table for this test.
+--
+
+   INITIALIZATION_TASKS : aliased RTEMS.INITIALIZATION_TASKS_TABLE( 1 .. 1 ) := 
+   (1=>
+     (
+       RTEMS.BUILD_NAME( 'U', 'I', '1', ' ' ),        -- task name
+       2048,                                          -- stack size
+       1,                                             -- priority
+       RTEMS.DEFAULT_ATTRIBUTES,                      -- attributes
+       TMTEST.INIT'ACCESS,                            -- entry point
+       RTEMS.NO_PREEMPT,                              -- initial mode
+       0                                              -- argument list
+     )
+   );
+
+--
+--  This is the Configuration Table for this test.
+--
+
+   CONFIGURATION : aliased RTEMS.CONFIGURATION_TABLE := (
+      RTEMS.NULL_ADDRESS,        -- will be replaced by BSP
+      256 * 1024,                -- executive RAM size
+      111,                       -- maximum # tasks
+      110,                       -- maximum # timers
+      101,                       -- maximum # semaphores
+      0,                         -- maximum # message queues
+      0,                         -- maximum # messages
+      0,                         -- maximum # partitions
+      0,                         -- maximum # regions
+      0,                         -- maximum # dp memory areas
+      0,                         -- maximum # periods
+      0,                         -- maximum # user extensions
+      RTEMS.MILLISECONDS_TO_MICROSECONDS(10), -- # us in a tick
+      0                          -- # ticks in a timeslice
+  );
+
+end TMTEST;
